﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.WindowsAzure.StorageClient;
using System.Data.Services.Common;

namespace DoodleJoyModels
{
    [DataServiceKey("PartitionKey", "RowKey")]
    public class Subscription
    {
        public string PartitionKey { get; set; }
        public string RowKey { get; set; }
        public string NotificationUri { get; set; }

        public Subscription()
        {
            PartitionKey = Guid.NewGuid().ToString();
            RowKey = string.Empty;
        }
    }

    [DataServiceKey("PartitionKey", "RowKey")]
    public class Doodle
    {
        public string PartitionKey { get; set; }
        public string RowKey { get; set; }
        public DateTime Timestamp { get; set; }
        public string Title { get; set; }
        public string ImageUri { get; set; }

        public Doodle()
        {
            this.PartitionKey = string.Empty;
            this.RowKey = (DateTime.MaxValue.Ticks - DateTime.UtcNow.Ticks).ToString("d19") + Guid.NewGuid().ToString();
        }
    }
}