﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using DoodleJoyModels;
using System.Data.Services.Client;

namespace DoodleJoyPhone
{
    public class MainViewModel : INotifyPropertyChanged
    {
        public MainViewModel() { }

        // update this to point to your running service
        public Uri ServiceUri { get { return new Uri("http://127.0.0.1:81/service"); } }

        public DataServiceCollection<Doodle> Doodles { get; private set; }

        private bool isLoading;
        public bool IsLoading
        {
            get { return isLoading; }
            set
            {
                if (isLoading != value)
                {
                    isLoading = value;
                    NotifyPropertyChanged("IsLoading");
                }
            }
        }

        public bool IsDataLoaded
        {
            get;
            private set;
        }

        private void LoadCompleted(object sender, LoadCompletedEventArgs e)
        {
            IsLoading = false;
            NotifyPropertyChanged("Doodles");
        }

        public void LoadData()
        {
            IsLoading = true;
            if (Doodles == null)
            {
                Doodles = new DataServiceCollection<Doodle>(new DoodleData(ServiceUri));
                Doodles.LoadCompleted += LoadCompleted;
            }
            Doodles.LoadAsync(new Uri("/Doodles", UriKind.Relative));

            this.IsDataLoaded = true;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                Deployment.Current.Dispatcher.BeginInvoke(() =>
                {
                    handler(this, new PropertyChangedEventArgs(propertyName));
                });
            }
        }
    }
}